<template>
<v-app>
  <v-container>
      <h2 class="my-3">Gestion des langues</h2>
      <div id="langue">
      <h3>La liste des langues disponible</h3>
        <br>
        <table class="center" border="1"> <!-- Récupération des langues ajoutés dans la base -->
          <tr>
            <th>ISO</th>
            <th>Nom</th>
          </tr>
          <tr v-for="langue in result" :key="langue.isolangue">
            <td>{{ langue.isolangue }}</td>
            <td>{{ langue.libellelangue }}</td>
          </tr>
        </table>
      </div>
      <br>
      <h3>Ajouter une langue</h3>
      <v-layout row wrap><!-- Ajouter une langue -->
        <v-flex md4>
          <v-text-field v-model="isolangue" label="ISO de la langue"></v-text-field> <!-- Champ ISO à remplir-->
        </v-flex>
        <v-flex md4 offset-md1>
          <v-text-field v-model="libellelangue" label="Libellé de la langue"></v-text-field> <!-- Champ libellé à remplir-->
        </v-flex>
      </v-layout>
      <v-btn outline color="light-green darken-1" v-on:click="addLangue()">Ajouter</v-btn> <!-- Bouton Ajouter -->
    <br>
    <h3>Modifier une langue</h3> <!-- Modifier une langue -->
    <v-layout row wrap>
      <v-flex md4>
        <v-select label="Choisir une langue" v-model="modifierLangue" v-bind:items="result" item-text="libellelangue" item-value="isolangue">
        </v-select>
      </v-flex>
      <v-flex md4 offset-md1>
        <v-btn outline color="primary" v-on:click="idLangue()">Choisir</v-btn>
      </v-flex>
    </v-layout>
    <div v-for="choix in choixlangue" :key="choix.isolangue">
    <v-layout row wrap>
      <v-flex md4>
        <v-text-field label="Modifier ISO" v-model="choix.isolangue"></v-text-field>
      </v-flex>
      <v-flex md4>
        <v-text-field label="Modifier le nom" v-model=" choix.libellelangue "></v-text-field>
      </v-flex>
      </v-layout>
      <v-btn outline color="warning" v-on:click="putLangue()">Appliquer</v-btn>
    </div>
    <br>
    <h3>Supprimer une langue</h3> <!-- Supprimer une langue -->
    <!--<div v-for="(langue, index) in result" :key="langue.isolangue" :index="index">
      <v-list>
        <v-list-tile>
          <v-list-tile v-text=" langue.libellelangue " ></v-list-tile>
        </v-list-tile>
      </v-list>
    </div> -->
    <v-layout row wrap>
      <v-flex md4>
        <v-select label="Supprimer une langue" v-model="supprimeLangue" v-bind:items="result" item-text="libellelangue" item-value="isolangue">
        </v-select>
      </v-flex>
      <v-flex md4 offset-md1>
        <v-btn outline color="error" @click.native.stop="dialog = true">Supprimer</v-btn>
      </v-flex>
    </v-layout>
    <v-dialog v-model="dialog" max-width="350">
      <v-card>
        <v-card-title class="headline">Confirmation de suppression</v-card-title>
        <v-card-text>Etes-vous sûr de vouloir supprimer la langue ?</v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn outline color="green darken-1" flat="flat" @click.native="dialog = false">Annuler</v-btn>
          <v-btn outline color="error" flat="flat" v-on:click="deleteLangue()" @click.native="dialog = false">Supprimer</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-container>
   </v-app>
</template>

<script>
export default {
  data () {
    return {
      result: [],
      choixlangue: [],
      isolangue: '',
      libellelangue: '',
      supprimeLangue: '',
      iso: '',
      libelle: '',
      modifierisolangue: '',
      modifierlibellelangue: '',
      modifierLangue: '',
      dialog: false
    }
  },
  mounted: function () {
    this.getLangue()
  },
  methods: {
    getLangue: function () {
      this.$http.get('http://localhost:3000/langue').then(response => {
        this.result = response.body
      })
    },
    addLangue: function () {
      const ajoutlangue = { /* Variable sous forme de tableau */
        iso: this.isolangue, /* récupération de l'iso*/
        libelle: this.libellelangue /* récupération du libellé*/
      }
      if (ajoutlangue.iso === '') { /* Si la valeur est vide, on met une alerte sinon on passe */
        alert('Veillez saisir avant d\'ajouter une langue')
      } else {
        this.$http.post('http://localhost:3000/langue', ajoutlangue) /* On envoie les données à l'adresse du serveur avec l'option ajoutlangue*/ 
        .then(response => {
          console.log('POST : ', response)
          this.getLangue()
        })
      }
    },
    idLangue: function () {
      this.$http.get('http://localhost:3000/langue/' + this.modifierLangue)
      .then(response => {
        this.choixlangue = response.body
      })
    },
    putLangue: function () {
      const modifierlangue = {
        iso: this.modifierisolangue,
        libelle: this.modifierlibellelangue
      }
      this.$http.put('http://localhost:3000/langue/' + this.modifierLangue, modifierlangue)
      .then(response => {
        console.log('PUT :', response)
        this.getLangue()
      })
    },
    deleteLangue: function () {
      if (this.supprimeLangue === '') {
        alert('Veillez choisir une langue avant de supprimer')
      } else {
        const index = this.result.findIndex(el => el.supprimeLangue !== this.supprimeLangue)
        console.log('DELETE Langue : ', index, this.supprimeLangue)
        this.result.splice(index, 1)
      /*
        this.$http.delete('http://localhost:3000/langue/' + this.supprimeLangue)
        .then(response => {
          console.log('DELETE :', response)
        })
        .catch(response => {
          console.log('ERROR : ', response.status)
        }) */
      }
    }
  }
}
</script>